Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing.text
Class JTextComponent

    java.lang.Object
      |
      +--java.awt.Component
            |
            +--java.awt.Container
                  |
                  +--javax.swing.JComponent
                        |
                        +--javax.swing.text.JTextComponent

Direct Known Subclasses:
  JEditorPane, JTextArea, JTextField

public abstract class JTextComponent
extends JComponent
implements Scrollable, Accessible

JTextComponent is the base class for swing text components. It tries to be compatible with the java.awt.TextComponent class where it can reasonably do so. Also provided are other services for additional flexibility (beyond the pluggable UI and bean support).

Caret Changes
  The caret is a pluggable object in swing text components. Notification of changes to the caret position and the selection are sent to implementations of the CaretListener interface that have been registered with the text component. The UI will install a default caret unless a customized caret has been set.
Commands

  Text components provide a number of commands that can be used to manipulate the component. This is essentially the way that the component expresses its capabilities. These are expressed in terms of the swing Action interface, using the TextAction implementation. The set of commands supported by the text component can be found with the `getActions()` method. These actions can be bound to key events, fired from buttons, etc.

Keymaps

  To facilitate flexible use of the keyboard, support for creating keymaps and binding various keystrokes to some kind of action is provided. In order to allow keymaps to be shared across multiple text components, they can use actions that extend TextAction. TextAction can determine which JTextComponent most recently has or had focus and therefore is the subject of the action (In the case that the ActionEvent sent to the action doesn't contain the target text component as its source).

  The use of the keymap is encouraged, but backward compatibilty with the awt mechanism is provided by giving the listeners a chance to steal the event by consuming it. Keyboard event distribution is handled in the following order, with each distribution capable of consuming the event.

  1. focus manager
  2. registered KeyListener's
  3. keymap handling using the current keymap
  4. keyboard handling in JComponent (e.g. accelerators, component navigation, etc.).

  By default the component will create a keymap (named DEFAULT_KEYMAP) that is shared by all JTextComponent instances as the default keymap. Typically a look-and-feel implementation will install a different keymap that resolves to the default keymap for those bindings not found in the different keymap. The minimal bindings include:

  - inserting content into the editor for the printable keys.
  - removing content with the backspace and del keys.
  - caret movement forward and backward
Model/View Split

  The text components have a model-view split. A text component pulls together the objects used to represent the model, view, and controller. The text document model may be shared by other views which act as observers of the model (e.g. a document may be shared by multiple components).

  The model is defined by the `Document` interface. This is intended to provide a flexible text storage mechanism that tracks change during edits and can be extended to more sophisticated models. The model interfaces are meant to capture the capabilities of expression given by SGML, a system used to express a wide variety of content. Each modification to the document causes notification of the details of the change to be sent to all observers in the form of a `DocumentEvent` which allows the views to stay up to date with the model. This event is sent to observers that have implemented the `DocumentListener` interface and registered interest with the model being observed.

Location Information
  The capability of determining the location of text in the view is provided. There are two methods, `modelToView(int)` and `viewToModel(java.awt.Point)` for determining this information.
Undo/Redo support
  Support for an edit history mechanism is provided to allow undo/redo operations. The text component does not itself provide the history buffer by default, but does provide the UndoableEdit records that can be used in conjunction with a history buffer to provide the undo/redo support. The support is provided by the Document model, which allows one to attach UndoableEditListener implementations.
Thread Safety
  The swing text components provide some support of thread safe operations. Because of the high level of configurability of the text components, it is possible to circumvent the protection provided. The protection primarily comes from the model, so the documentation of AbstractDocument describes the assumptions of the protection provided. The methods that are safe to call asynchronously are marked with comments.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. A future release of Swing will provide support for long term persistence.

See Also:
  `Document`, `DocumentEvent`, `DocumentListener`, `Caret`, `CaretEvent`, `CaretListener`, `TextUI`, `View`, `ViewFactory`, Serialized Form

Inner Class Summary
`class` | `JTextComponent.AccessibleJTextComponent` Accessibility implementation for JTextComponent.
`static class` | `JTextComponent.KeyBinding` Binding record for creating key bindings.

Inner classes inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Field Summary
`static java.lang.String` | `DEFAULT_KEYMAP` This is the name of the default keymap that will be shared by all JTextComponent instances unless they have had a different keymap set.
`static java.lang.String` | `FOCUS_ACCELERATOR_KEY` The bound property name for the focus accelerator.

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Constructor Summary
`JTextComponent()` Creates a new JTextComponent.

Method Summary
`void` | `addCaretListener(CaretListener listener)` Adds a caret listener for notification of any changes to the caret.
`static Keymap` | `addKeymap(java.lang.String nm, Keymap parent)` Adds a new keymap into the keymap hierarchy.
`void` | `copy()` Transfers the currently selected range in the associated text model to the system clipboard, leaving the contents in the text model.
`void` | `cut()` Transfers the currently selected range in the associated text model to the system clipboard, removing the contents from the model.
`protected void` | `fireCaretUpdate(CaretEvent e)` Notifies all listeners that have registered interest for notification on this event type.
`AccessibleContext` | `getAccessibleContext()` Gets the AccessibleContext associated with this JComponent.
`Action[]` | `getActions()` Fetches the command list for the editor.
`Caret` | `getCaret()` Fetches the caret that allows text-oriented navigation over the view.
`java.awt.Color` | `getCaretColor()` Fetches the current color used to render the caret.
`int` | `getCaretPosition()` Returns the position of the text insertion caret for the text component.
`java.awt.Color` | `getDisabledTextColor()` Fetches the current color used to render the selected text.
`Document` | `getDocument()` Fetches the model associated with the editor.
`char` | `getFocusAccelerator()` Returns the key accelerator that will cause the receiving text component to get the focus.
`Highlighter` | `getHighlighter()` Fetches the object responsible for making highlights.
`Keymap` | `getKeymap()` Fetches the keymap currently active in this text component.
`static Keymap` | `getKeymap(java.lang.String nm)` Fetches a named keymap previously added to the document.
`java.awt.Insets` | `getMargin()` Returns the margin between the text component's border and its text.
`java.awt.Dimension` | `getPreferredScrollableViewportSize()` Returns the preferred size of the viewport for a view component.
`int` | `getScrollableBlockIncrement(java.awt.Rectangle visibleRect, int orientation, int direction)` Components that display logical rows or columns should compute the scroll increment that will completely expose one block of rows or columns, depending on the value of orientation.
`boolean` | `getScrollableTracksViewportHeight()` Return true if a viewport should always force the height of this Scrollable to match the height of the viewport.
`boolean` | `getScrollableTracksViewportWidth()` Return true if a viewport should always force the width of this Scrollable to match the width of the viewport.
`int` | `getScrollableUnitIncrement(java.awt.Rectangle visibleRect, int orientation, int direction)` Components that display logical rows or columns should compute the scroll increment that will completely expose one new row or column, depending on the value of orientation.
`java.lang.String` | `getSelectedText()` Returns the selected text contained in this TextComponent.
`java.awt.Color` | `getSelectedTextColor()` Fetches the current color used to render the selected text.
`java.awt.Color` | `getSelectionColor()` Fetches the current color used to render the selection.
`int` | `getSelectionEnd()` Returns the selected text's end position.
`int` | `getSelectionStart()` Returns the selected text's start position.
`java.lang.String` | `getText()` Returns the text contained in this TextComponent.
`java.lang.String` | `getText(int offs, int len)` Fetches a portion of the text represented by the component.
`TextUI` | `getUI()` Fetches the user-interface factory for this text-oriented editor.
`boolean` | `isEditable()` Returns the boolean indicating whether this TextComponent is editable or not.
`boolean` | `isFocusTraversable()` Returns true if the focus can be traversed.
`boolean` | `isOpaque()` Returns true if this component is completely opaque.
`static void` | `loadKeymap(Keymap map, JTextComponent.KeyBinding[] bindings, Action[] actions)` Loads a keymap with a bunch of bindings.
`java.awt.Rectangle` | `modelToView(int pos)` Converts the given location in the model to a place in the view coordinate system.
`void` | `moveCaretPosition(int pos)` Moves the caret to a new position, leaving behind a mark defined by the last time setCaretPosition was called.
`protected java.lang.String` | `paramString()` Returns a string representation of this JTextComponent.
`void` | `paste()` Transfers the contents of the system clipboard into the associated text model.
`protected void` | `processComponentKeyEvent(java.awt.event.KeyEvent e)` Processes any key events that the component itself recognizes.
`void` | `read(java.io.Reader in, java.lang.Object desc)` Initializes from a stream.
`void` | `removeCaretListener(CaretListener listener)` Removes a caret listener.
`static Keymap` | `removeKeymap(java.lang.String nm)` Removes a named keymap previously added to the document.
`void` | `removeNotify()` Notifies this component that it has been removed from its container.
`void` | `replaceSelection(java.lang.String content)` Replaces the currently selected content with new content represented by the given string.
`void` | `select(int selectionStart, int selectionEnd)` Selects the text found between the specified start and end locations.
`void` | `selectAll()` Selects all the text in the TextComponent.
`void` | `setCaret(Caret c)` Sets the caret to be used.
`void` | `setCaretColor(java.awt.Color c)` Sets the current color used to render the caret.
`void` | `setCaretPosition(int position)` Sets the position of the text insertion caret for the TextComponent.
`void` | `setDisabledTextColor(java.awt.Color c)` Sets the current color used to render the disabled text.
`void` | `setDocument(Document doc)` Associates the editor with a text document.
`void` | `setEditable(boolean b)` Sets the specified boolean to indicate whether or not this TextComponent should be editable.
`void` | `setEnabled(boolean b)` Enables or disables this component, depending on the value of the parameter `b`.
`void` | `setFocusAccelerator(char aKey)` Sets the key accelerator that will cause the receiving text component to get the focus.
`void` | `setHighlighter(Highlighter h)` Sets the highlighter to be used.
`void` | `setKeymap(Keymap map)` Sets the keymap to use for binding events to actions.
`void` | `setMargin(java.awt.Insets m)` Sets margin space between the text component's border and its text.
`void` | `setOpaque(boolean o)` Sets whether or not the UI should render a background.
`void` | `setSelectedTextColor(java.awt.Color c)` Sets the current color used to render the selected text.
`void` | `setSelectionColor(java.awt.Color c)` Sets the current color used to render the selection.
`void` | `setSelectionEnd(int selectionEnd)` Sets the selection end to the specified position.
`void` | `setSelectionStart(int selectionStart)` Sets the selection start to the specified position.
`void` | `setText(java.lang.String t)` Sets the text of this TextComponent to the specified text.
`void` | `setUI(TextUI ui)` Sets the user-interface factory for this text-oriented editor
`void` | `updateUI()` Reloads the pluggable UI.
`int` | `viewToModel(java.awt.Point pt)` Converts the given place in the view coordinate system to the nearest representative location in the model.
`void` | `write(java.io.Writer out)` Stores the contents of the model into the given stream.

Methods inherited from class javax.swing.JComponent
`addAncestorListener, addNotify, addPropertyChangeListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getAlignmentX, getAlignmentY, getAutoscrolls, getBorder, getBounds, getClientProperty, getComponentGraphics, getConditionForKeyStroke, getDebugGraphicsOptions, getGraphics, getHeight, getInsets, getInsets, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getUIClassID, getVisibleRect, getWidth, getX, getY, grabFocus, hasFocus, isDoubleBuffered, isFocusCycleRoot, isLightweightComponent, isManagingFocus, isOptimizedDrawingEnabled, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, processFocusEvent, processKeyEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removePropertyChangeListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setDebugGraphicsOptions, setDoubleBuffered, setFont, setForeground, setMaximumSize, setMinimumSize, setNextFocusableComponent, setPreferredSize, setRequestFocusEnabled, setToolTipText, setUI, setVisible, unregisterKeyboardAction, update`

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, addImpl, countComponents, deliverEvent, doLayout, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getLayout, insets, invalidate, isAncestorOf, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setLayout, validate, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addKeyListener, addMouseListener, addMouseMotionListener, bounds, checkImage, checkImage, contains, createImage, createImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, getBackground, getBounds, getColorModel, getCursor, getFont, getFontMetrics, getForeground, getLocale, getLocation, getLocationOnScreen, getName, getParent, getPeer, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hide, imageUpdate, inside, isEnabled, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, printAll, processComponentEvent, processMouseEvent, remove, removeComponentListener, removeFocusListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setCursor, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### FOCUS_ACCELERATOR_KEY

    public static final java.lang.String FOCUS_ACCELERATOR_KEY

  The bound property name for the focus accelerator.

### DEFAULT_KEYMAP

    public static final java.lang.String DEFAULT_KEYMAP

  This is the name of the default keymap that will be shared by all JTextComponent instances unless they have had a different keymap set.

Constructor Detail

### JTextComponent

    public JTextComponent()

  Creates a new JTextComponent. Listeners for caret events are established, and the pluggable UI installed. The component is marked as editable. No layout manager is used, because layout is managed by the view subsystem of text. The document model is set to null.

Method Detail

### getUI

    public TextUI getUI()

  Fetches the user-interface factory for this text-oriented editor.
  Returns:
    the factory

### setUI

    public void setUI(TextUI ui)

  Sets the user-interface factory for this text-oriented editor
  Parameters:
    `ui` - the factory

### updateUI

    public void updateUI()

  Reloads the pluggable UI. The key used to fetch the new interface is getUIClassID(). The type of the UI is TextUI. invalidate() is called after setting the UI.
  Overrides:
    updateUI in class JComponent

### isOpaque

    public boolean isOpaque()

  Returns true if this component is completely opaque. This is used in painting backgrounds.
  Returns:
    true if this component is completely opaque.
  Overrides:
    isOpaque in class JComponent

### setOpaque

    public void setOpaque(boolean o)

  Sets whether or not the UI should render a background.
  Parameters:
    `o` - true if should render a background
  Overrides:
    setOpaque in class JComponent

### addCaretListener

    public void addCaretListener(CaretListener listener)

  Adds a caret listener for notification of any changes to the caret.
  Parameters:
    `listener` - the listener
  See Also:
    `CaretEvent`

### removeCaretListener

    public void removeCaretListener(CaretListener listener)

  Removes a caret listener.
  Parameters:
    `listener` - the listener
  See Also:
    `CaretEvent`

### fireCaretUpdate

    protected void fireCaretUpdate(CaretEvent e)

  Notifies all listeners that have registered interest for notification on this event type. The event instance is lazily created using the parameters passed into the fire method. The listener list is processed in a last-to-first manner.
  Parameters:
    `e` - the event
  See Also:
    `EventListenerList`

### setDocument

    public void setDocument(Document doc)

  Associates the editor with a text document. The currently registered factory is used to build a view for the document, which gets displayed by the editor after revalidation. A PropertyChange event ("document") is propagated to each listener.
  Parameters:
    `doc` - the document to display/edit
  See Also:
    `getDocument()`

### getDocument

    public Document getDocument()

  Fetches the model associated with the editor. This is primarily for the UI to get at the minimal amount of state required to be a text editor. Subclasses will return the actual type of the model which will typically be something that extends Document.
  Returns:
    the model

### getActions

    public Action[] getActions()

  Fetches the command list for the editor. This is the list of commands supported by the plugged-in UI augmented by the collection of commands that the editor itself supports. These are useful for binding to events, such as in a keymap.
  Returns:
    the command list

### setMargin

    public void setMargin(java.awt.Insets m)

  Sets margin space between the text component's border and its text. The text component's default Border object will use this value to create the proper margin. However, if a non-default border is set on the text component, it is that Border object's responsibility to create the appropriate margin space (else this property will effectively be ignored). This causes a redraw of the component. A PropertyChange event ("margin") is sent to all listeners.
  Parameters:
    `m` - the space between the border and the text

### getMargin

    public java.awt.Insets getMargin()

  Returns the margin between the text component's border and its text.
  Returns:
    the margin

### getCaret

    public Caret getCaret()

  Fetches the caret that allows text-oriented navigation over the view.
  Returns:
    the caret

### setCaret

    public void setCaret(Caret c)

  Sets the caret to be used. By default this will be set by the UI that gets installed. This can be changed to a custom caret if desired. Setting the caret results in a PropertyChange event ("caret") being fired.
  Parameters:
    `c` - the caret
  See Also:
    `getCaret()`

### getHighlighter

    public Highlighter getHighlighter()

  Fetches the object responsible for making highlights.
  Returns:
    the highlighter

### setHighlighter

    public void setHighlighter(Highlighter h)

  Sets the highlighter to be used. By default this will be set by the UI that gets installed. This can be changed to a custom highlighter if desired. The highlighter can be set to null to disable it. A PropertyChange event ("highlighter") is fired when a new highlighter is installed.
  Parameters:
    `h` - the highlighter
  See Also:
    `getHighlighter()`

### setKeymap

    public void setKeymap(Keymap map)

  Sets the keymap to use for binding events to actions. Setting to null effectively disables keyboard input. A PropertyChange event ("keymap") is fired when a new keymap is installed.
  Parameters:
    `map` - the keymap
  See Also:
    `getKeymap()`

### getKeymap

    public Keymap getKeymap()

  Fetches the keymap currently active in this text component.
  Returns:
    the keymap

### addKeymap

    public static Keymap addKeymap(java.lang.String nm,
                                   Keymap parent)

  Adds a new keymap into the keymap hierarchy. Keymap bindings resolve from bottom up so an attribute specified in a child will override an attribute specified in the parent.
  Parameters:
    `nm` - the name of the keymap (must be unique within the collection of named keymaps in the document). The name may be null if the keymap is unnamed, but the caller is responsible for managing the reference returned as an unnamed keymap can't be fetched by name.
    `parent` - the parent keymap. This may be null if unspecified bindings need not be resolved in some other keymap.
  Returns:
    the keymap

### removeKeymap

    public static Keymap removeKeymap(java.lang.String nm)

  Removes a named keymap previously added to the document. Keymaps with null names may not be removed in this way.
  Parameters:
    `nm` - the name of the keymap to remove
  Returns:
    the keymap that was removed

### getKeymap

    public static Keymap getKeymap(java.lang.String nm)

  Fetches a named keymap previously added to the document. This does not work with null-named keymaps.
  Parameters:
    `nm` - the name of the keymap
  Returns:
    the keymap

### loadKeymap

    public static void loadKeymap(Keymap map,
                                  JTextComponent.KeyBinding[] bindings,
                                  Action[] actions)

  Loads a keymap with a bunch of bindings. This can be used to take a static table of definitions and load them into some keymap. The following example illustrates an example of binding some keys to the cut, copy, and paste actions associated with a JTextComponent. A code fragment to accomplish this might look as follows:

         static final JTextComponent.KeyBinding[] defaultBindings = {
           new JTextComponent.KeyBinding(
             KeyStroke.getKeyStroke(KeyEvent.VK_C, InputEvent.CTRL_MASK),
             DefaultEditorKit.copyAction),
           new JTextComponent.KeyBinding(
             KeyStroke.getKeyStroke(KeyEvent.VK_V, InputEvent.CTRL_MASK),
             DefaultEditorKit.pasteAction),
           new JTextComponent.KeyBinding(
             KeyStroke.getKeyStroke(KeyEvent.VK_X, InputEvent.CTRL_MASK),
             DefaultEditorKit.cutAction),
         };

         JTextComponent c = new JTextPane();
         Keymap k = c.getKeymap();
         JTextComponent.loadKeymap(k, defaultBindings, c.getActions());

  The sets of bindings and actions may be empty but must be non-null.
  Parameters:
    `map` - the keymap
    `bindings` - the bindings
    `actions` - the set of actions

### getCaretColor

    public java.awt.Color getCaretColor()

  Fetches the current color used to render the caret.
  Returns:
    the color

### setCaretColor

    public void setCaretColor(java.awt.Color c)

  Sets the current color used to render the caret. Setting to null effectively restores the default color. Setting the color results in a PropertyChange event ("caretColor") being fired.
  Parameters:
    `c` - the color
  See Also:
    `getCaretColor()`

### getSelectionColor

    public java.awt.Color getSelectionColor()

  Fetches the current color used to render the selection.
  Returns:
    the color

### setSelectionColor

    public void setSelectionColor(java.awt.Color c)

  Sets the current color used to render the selection. Setting the color to null is the same as setting Color.white. Setting the color results in a PropertyChange event ("selectionColor").
  Parameters:
    `c` - the color
  See Also:
    `getSelectionColor()`

### getSelectedTextColor

    public java.awt.Color getSelectedTextColor()

  Fetches the current color used to render the selected text.
  Returns:
    the color

### setSelectedTextColor

    public void setSelectedTextColor(java.awt.Color c)

  Sets the current color used to render the selected text. Setting the color to null is the same as Color.black. Setting the color results in a PropertyChange event ("selectedTextColor") being fired.
  Parameters:
    `c` - the color
  See Also:
    `getSelectedTextColor()`

### getDisabledTextColor

    public java.awt.Color getDisabledTextColor()

  Fetches the current color used to render the selected text.
  Returns:
    the color

### setDisabledTextColor

    public void setDisabledTextColor(java.awt.Color c)

  Sets the current color used to render the disabled text. Setting the color fires off a PropertyChange event ("disabledTextColor").
  Parameters:
    `c` - the color
  See Also:
    `getDisabledTextColor()`

### replaceSelection

    public void replaceSelection(java.lang.String content)

  Replaces the currently selected content with new content represented by the given string. If there is no selection this amounts to an insert of the given text. If there is no replacement text this amounts to a removal of the current selection.

  This is the method that is used by the default implementation of the action for inserting content that gets bound to the keymap actions.

  This method is thread safe, although most Swing methods are not. Please see Threads and Swing for more information.

  If the component is not currently editable, beep and return. Then if the underlying model is null, do nothing.

  Parameters:
    `content` - the content to replace the selection with

### getText

    public java.lang.String getText(int offs,
                                    int len)
                             throws BadLocationException

  Fetches a portion of the text represented by the component. Returns an empty string if length is 0.
  Parameters:
    `offs` - the offset >= 0
    `len` - the length >= 0
  Returns:
    the text
  Throws:
    BadLocationException - if the offset or length are invalid

### modelToView

    public java.awt.Rectangle modelToView(int pos)
                                   throws BadLocationException

  Converts the given location in the model to a place in the view coordinate system.
  Parameters:
    `pos` - the position >= 0
  Returns:
    the coordinates as a rectangle, with (r.x, r.y) as the location in the coordinate system
  Throws:
    BadLocationException - if the given position does not represent a valid location in the associated document
  See Also:
    `TextUI.modelToView(javax.swing.text.JTextComponent, int)`

### viewToModel

    public int viewToModel(java.awt.Point pt)

  Converts the given place in the view coordinate system to the nearest representative location in the model.
  Parameters:
    `pt` - the location in the view to translate
  Returns:
    the offset >= 0 from the start of the document
  See Also:
    `TextUI.viewToModel(javax.swing.text.JTextComponent, java.awt.Point)`

### cut

    public void cut()

  Transfers the currently selected range in the associated text model to the system clipboard, removing the contents from the model. The current selection is reset. Does nothing for null selections.

### copy

    public void copy()

  Transfers the currently selected range in the associated text model to the system clipboard, leaving the contents in the text model. The current selection is remains intact. Does nothing for null selections.

### paste

    public void paste()

  Transfers the contents of the system clipboard into the associated text model. If there is a selection in the associated view, it is replaced with the contents of the clipboard. If there is no selection, the clipboard contents are inserted in front of the current insert position in the associated view. If the clipboard is empty, does nothing.
  See Also:
    `replaceSelection(java.lang.String)`

### moveCaretPosition

    public void moveCaretPosition(int pos)

  Moves the caret to a new position, leaving behind a mark defined by the last time setCaretPosition was called. This forms a selection.
  Parameters:
    `pos` - the position
  See Also:
    `setCaretPosition(int)`

### setFocusAccelerator

    public void setFocusAccelerator(char aKey)

  Sets the key accelerator that will cause the receiving text component to get the focus. The accelerator will be the key combination of the alt key and the character given (converted to upper case). By default, there is no focus accelerator key. Any previous key accelerator setting will be superseded. A '\0' key setting will be registered, and has the effect of turning off the focus accelerator. When the new key is set, a PropertyChange event (FOCUS_ACCELERATOR_KEY) will be fired.
  Parameters:
    `aKey` - the key
  See Also:
    `getFocusAccelerator()`

### getFocusAccelerator

    public char getFocusAccelerator()

  Returns the key accelerator that will cause the receiving text component to get the focus. Return '\0' if no focus accelerator has been set.
  Returns:
    the key

### read

    public void read(java.io.Reader in,
                     java.lang.Object desc)
              throws java.io.IOException

  Initializes from a stream. This creates a model of the type appropriate for the component and initializes the model from the stream. By default this will load the model as plain text. Previous contents of the model are discarded.
  Parameters:
    `in` - The stream to read from
    `desc` - An object describing the stream. This might be a string, a File, a URL, etc. Some kinds of documents (such as html for example) might be able to make use of this information. If non-null, it is added as a property of the document.
  Throws:
    java.io.IOException - as thrown by the stream being used to initialize.
  See Also:
    `EditorKit.createDefaultDocument()`, `setDocument(javax.swing.text.Document)`, `PlainDocument`

### write

    public void write(java.io.Writer out)
               throws java.io.IOException

  Stores the contents of the model into the given stream. By default this will store the model as plain text.
  Parameters:
    `out` - the output stream
  Throws:
    java.io.IOException - on any I/O error

### removeNotify

    public void removeNotify()

  Notifies this component that it has been removed from its container. This is used to remove the reference to this component as the last focused component, if such a reference exists (i.e. to support TextAction).
  Overrides:
    removeNotify in class JComponent

### setEnabled

    public void setEnabled(boolean b)

  Enables or disables this component, depending on the value of the parameter `b`. An enabled component can respond to user input and generate events. Components are enabled initially by default. A repaint() is done after setting the new state.
  Parameters:
    `b` - If `true`, this component is enabled; otherwise this component is disabled.
  Overrides:
    setEnabled in class JComponent
  Since:
    JDK1.1
  See Also:
    `Component.isEnabled()`

### isFocusTraversable

    public boolean isFocusTraversable()

  Returns true if the focus can be traversed. This would be false for components like a disabled button.
  Returns:
    true if the focus is traversable
  Overrides:
    isFocusTraversable in class JComponent

### processComponentKeyEvent

    protected void processComponentKeyEvent(java.awt.event.KeyEvent e)

  Processes any key events that the component itself recognizes. This will be called after the focus manager and any interested listeners have been given a chance to steal away the event. This method will only be called is the event has not yet been consumed. This method is called prior to the keyboard UI logic.

  This is implemented to take a default action, typically inserting the character into the document as content. Subclasses would normally override this method if they process some key events themselves. If the event is processed, it should be consumed.

  Parameters:
    `e` - the event
  Overrides:
    processComponentKeyEvent in class JComponent

### setCaretPosition

    public void setCaretPosition(int position)

  Sets the position of the text insertion caret for the TextComponent. Note that the caret tracks change, so this may move if the underlying text of the component is changed. If the document is null, does nothing.
  Parameters:
    `position` - the position

### getCaretPosition

    public int getCaretPosition()

  Returns the position of the text insertion caret for the text component.
  Returns:
    the position of the text insertion caret for the text component >= 0

### setText

    public void setText(java.lang.String t)

  Sets the text of this TextComponent to the specified text. If the text is null or empty, has the effect of simply deleting the old text.

  This method is thread safe, although most Swing methods are not. Please see Threads and Swing for more information.

  Parameters:
    `t` - the new text to be set
  See Also:
    `getText(int, int)`

### getText

    public java.lang.String getText()

  Returns the text contained in this TextComponent. If the underlying document is null, will give a NullPointerException.
  Returns:
    the text
  See Also:
    `setText(java.lang.String)`

### getSelectedText

    public java.lang.String getSelectedText()

  Returns the selected text contained in this TextComponent. If the selection is null or the document empty, returns null.
  Returns:
    the text
  Throws:
    java.lang.IllegalArgumentException - if the selection doesn't have a valid mapping into the document for some reason
  See Also:
    `setText(java.lang.String)`

### isEditable

    public boolean isEditable()

  Returns the boolean indicating whether this TextComponent is editable or not.
  Returns:
    the boolean value
  See Also:
    `setEditable(boolean)`

### setEditable

    public void setEditable(boolean b)

  Sets the specified boolean to indicate whether or not this TextComponent should be editable. A PropertyChange event ("editable") is fired when the state is changed.
  Parameters:
    `b` - the boolean to be set
  See Also:
    `isEditable()`

### getSelectionStart

    public int getSelectionStart()

  Returns the selected text's start position. Return 0 for an empty document, or the value of dot if no selection.
  Returns:
    the start position >= 0

### setSelectionStart

    public void setSelectionStart(int selectionStart)

  Sets the selection start to the specified position. The new starting point is constrained to be before or at the current selection end.

  This is available for backward compatiblitity to code that called this method on java.awt.TextComponent. This is implemented to forward to the Caret implementation which is where the actual selection is maintained.

  Parameters:
    `selectionStart` - the start position of the text >= 0

### getSelectionEnd

    public int getSelectionEnd()

  Returns the selected text's end position. Return 0 if the document is empty, or the value of dot if there is no selection.
  Returns:
    the end position >= 0

### setSelectionEnd

    public void setSelectionEnd(int selectionEnd)

  Sets the selection end to the specified position. The new end point is constrained to be at or after the current selection start.

  This is available for backward compatiblitity to code that called this method on java.awt.TextComponent. This is implemented to forward to the Caret implementation which is where the actual selection is maintained.

  Parameters:
    `selectionEnd` - the end position of the text >= 0

### select

    public void select(int selectionStart,
                       int selectionEnd)

  Selects the text found between the specified start and end locations. This call is provided for backward compatibility. It is routed to a call to setCaretPosition followed by a call to moveCaretPostion. The preferred way to manage selection is by calling those methods directly.
  Parameters:
    `selectionStart` - the start position of the text >= 0
    `selectionEnd` - the end position of the text >= 0
  See Also:
    `setCaretPosition(int)`, `moveCaretPosition(int)`

### selectAll

    public void selectAll()

  Selects all the text in the TextComponent. Does nothing on a null or empty document.

### getPreferredScrollableViewportSize

    public java.awt.Dimension getPreferredScrollableViewportSize()

  Returns the preferred size of the viewport for a view component. This is implemented to do the default behavior of returning the preferred size of the component.
  Specified by:
    getPreferredScrollableViewportSize in interface Scrollable
  Returns:
    The preferredSize of a JViewport whose view is this Scrollable.

### getScrollableUnitIncrement

    public int getScrollableUnitIncrement(java.awt.Rectangle visibleRect,
                                          int orientation,
                                          int direction)

  Components that display logical rows or columns should compute the scroll increment that will completely expose one new row or column, depending on the value of orientation. Ideally, components should handle a partially exposed row or column by returning the distance required to completely expose the item.

  The default implementation of this is to simply return 10% of the visible area. Subclasses are likely to be able to provide a much more reasonable value.

  Specified by:
    getScrollableUnitIncrement in interface Scrollable
  Parameters:
    `visibleRect` - The view area visible within the viewport
    `orientation` - Either SwingConstants.VERTICAL or SwingConstants.HORIZONTAL.
    `direction` - Less than zero to scroll up/left, greater than zero for down/right.
  Returns:
    The "unit" increment for scrolling in the specified direction
  Throws:
    java.lang.IllegalArgumentException - for an invalid orientation
  See Also:
    `JScrollBar.setUnitIncrement(int)`

### getScrollableBlockIncrement

    public int getScrollableBlockIncrement(java.awt.Rectangle visibleRect,
                                           int orientation,
                                           int direction)

  Components that display logical rows or columns should compute the scroll increment that will completely expose one block of rows or columns, depending on the value of orientation.

  The default implementation of this is to simply return the visible area. Subclasses will likely be able to provide a much more reasonable value.

  Specified by:
    getScrollableBlockIncrement in interface Scrollable
  Parameters:
    `visibleRect` - The view area visible within the viewport
    `orientation` - Either SwingConstants.VERTICAL or SwingConstants.HORIZONTAL.
    `direction` - Less than zero to scroll up/left, greater than zero for down/right.
  Returns:
    The "block" increment for scrolling in the specified direction.
  Throws:
    java.lang.IllegalArgumentException - for an invalid orientation
  See Also:
    `JScrollBar.setBlockIncrement(int)`

### getScrollableTracksViewportWidth

    public boolean getScrollableTracksViewportWidth()

  Return true if a viewport should always force the width of this Scrollable to match the width of the viewport. For example a normal text view that supported line wrapping would return true here, since it would be undesirable for wrapped lines to disappear beyond the right edge of the viewport. Note that returning true for a Scrollable whose ancestor is a JScrollPane effectively disables horizontal scrolling.

  Scrolling containers, like JViewport, will use this method each time they are validated.

  Specified by:
    getScrollableTracksViewportWidth in interface Scrollable
  Returns:
    true if a viewport should force the Scrollables width to match its own.

### getScrollableTracksViewportHeight

    public boolean getScrollableTracksViewportHeight()

  Return true if a viewport should always force the height of this Scrollable to match the height of the viewport. For example a columnar text view that flowed text in left to right columns could effectively disable vertical scrolling by returning true here.

  Scrolling containers, like JViewport, will use this method each time they are validated.

  Specified by:
    getScrollableTracksViewportHeight in interface Scrollable
  Returns:
    true if a viewport should force the Scrollables height to match its own.

### getAccessibleContext

    public AccessibleContext getAccessibleContext()

  Gets the AccessibleContext associated with this JComponent. A new context is created if necessary.
  Specified by:
    getAccessibleContext in interface Accessible
  Returns:
    the AccessibleContext of this JComponent
  Overrides:
    getAccessibleContext in class JComponent

### paramString

    protected java.lang.String paramString()

  Returns a string representation of this JTextComponent. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.

  Overriding paramString() to provide information about the specific new aspects of the JFC components.

  Returns:
    a string representation of this JTextComponent.
  Overrides:
    paramString in class JComponent

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.